10  ' These values are constants and should not be changed by the user
80  '
90  '
100 ' Change these values to match your LCD module
110 '
120  _C_Lines = 2
130  _C_LineLength = 20
140  _C_4_L1_Start = 0		
150  _C_4_L2_Start = 64	
160  _C_4_L3_Start = 20	
170  _C_4_L4_Start = 84
180  _C_2_L1_Start = 0
190  _C_2_L2_Start = 64
200 '
250 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
300 ' Start of code
400 '
1110 GOSUB 11000            ' Initialise the LCD
1120 LCD_line1$ = "    Hello  World.   "
1130 LCD_line2$ = " This is a Maximite "
1135 LCD_Line3$ = "communicating with a"
1138 LCD_Line4$ = "4 line HD44780 LCD. "
1140 GOSUB 12000            ' send to the LCD
1150 END
1160 '
1170 '
1180 '
10000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
10010 ' LCD driver for standard 20 X 4 LCDs
10020 '               James Deakins July 2011, 
10024 ' based on the original 16 X 2 code by
10025 '               Geoff Graham, March 2011
10030 '
10040 ' For example:  HD44780 20x4
10070 '
10080 ' To use:
10090 '  - execute GOSUB 11000 to initialise display
10100 '  - then load the text strings into the
10110 '    variablesLCD_line1$, LCD_line2$, LCD_line3$ and LCD_line4$
10120 '  - execute GOSUB 12000 to display the text
10130 '
10140 ' See the file lcd.pdf for the schematic - but use the following
10145 ' pinout information instead of the pinouts on the schematic.
10150 ' Maximite pin 11 is RS, pin 12 is EN
10160 ' pins 13 to 16 are D4 to D7.  R/W is grounded
10180 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
10190 '
10200 '
11000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
11010 ' Initialise the LCD
11020 '
11030 FOR i = 11 TO 16 : SETPIN i, 9 : NEXT i
11040 _LCD_byte = &B0011 : GOSUB 13090 : PAUSE 5   ' reset
11050 _LCD_byte = &B0011 : GOSUB 13090 : PAUSE 5   ' reset
11060 _LCD_byte = &B0011 : GOSUB 13090 : PAUSE 5   ' reset
11070 _LCD_byte = &B0010 : GOSUB 13090 : PAUSE 2   ' 4 bit mode
11080 _LCD_byte = &B00101100 : GOSUB 13000         ' 4 bit, 2 lines (or 4 lines)
11090 _LCD_byte = &B00001100 : GOSUB 13000    ' display on, no cursor
11100 _LCD_byte = &B00000110 : GOSUB 13000    ' increment on write
11110 _LCD_byte = &B00000001 : GOSUB 13000    ' clear display
11115 pause 2
11120 RETURN
11130 '
11140 '
12000 '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
12010 ' send the ines of text to the LCD
12020 ' the text is in LCD_Line1$ and LCD_Line2$, and if it's a 4 line, also in LCD_Line3$ and LCD_Line4$
12025 _LCD_byte = &B00000001 : GOSUB 13000    ' clear display
12026 pause 50
12030 '
12035 if _C_Lines = 2 then
12036 	_LCD_byte = 128 + _C_2_L1_Start : GOSUB 13000    ' select the 1st line
12037 	FOR _LCD = 1 TO 20
12038   	_LCD_byte = ASC(MID$(LCD_Line1$, _LCD, 1))
12039    	PIN(11) = 1 : GOSUB 13000           ' send the character
12040 	NEXT _LCD
12041 	_LCD_byte = 128 + _C_2_L2_Start : GOSUB 13000    ' select the 2nd line
12042	FOR _LCD = 1 TO 20
12043		_LCD_byte = ASC(MID$(LCD_Line2$, _LCD, 1))
12044 		PIN(11) = 1 : GOSUB 13000           ' send the character
12045 	NEXT _LCD
12046 else
12048 	_LCD_byte = 128 + _C_4_L1_Start : GOSUB 13000    ' select the 1st line
12050  	FOR _LCD = 1 TO 20
12060   	_LCD_byte = ASC(MID$(LCD_Line1$, _LCD, 1))
12070     	PIN(11) = 1 : GOSUB 13000           ' send the character
12080 	NEXT _LCD
12090 	_LCD_byte = 128 + _C_4_L2_Start : GOSUB 13000    ' select the 2nd line 
12100 	FOR _LCD = 1 TO 20
12110   	_LCD_byte = ASC(MID$(LCD_Line2$, _LCD, 1))
12120   	PIN(11) = 1 : GOSUB 13000           ' send the character
12130 	NEXT _LCD
12132 	_LCD_byte = 128 + _C_4_L3_Start : GOSUB 13000    ' select the 3rd line 
12134 	FOR _LCD = 1 TO 20
12136   	_LCD_byte = ASC(MID$(LCD_Line3$, _LCD, 1))
12138     	PIN(11) = 1 : GOSUB 13000           ' send the character
12140 	NEXT _LCD
12142 	_LCD_byte = 128 + _C_4_L4_Start : GOSUB 13000    ' select the 4th line 
12144 	FOR _LCD = 1 TO 20
12146   	_LCD_byte = ASC(MID$(LCD_Line4$, _LCD, 1))
12148     	PIN(11) = 1 : GOSUB 13000           ' send the character
12150 	NEXT _LCD
12160 ENDIF
12165 RETURN
12170 '
12180 '
13000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
13010 ' Send a byte to the LCD
13020 ' the data to be sent is in _LCD_byte
13030 '
13040 PIN(13) = _LCD_byte AND &B00010000      ' output the 1st 4 bits
13050 PIN(14) = _LCD_byte AND &B00100000
13060 PIN(15) = _LCD_byte AND &B01000000
13070 PIN(16) = _LCD_byte AND &B10000000
13080 PIN(12) = 1 : PIN(12) = 0               ' tell lcd to accept data
13090 ' Entry point to send just 4 bits to the LCD
13100 PIN(13) = _LCD_byte AND &B00000001      ' output the 2nd 4 bits
13110 PIN(14) = _LCD_byte AND &B00000010
13120 PIN(15) = _LCD_byte AND &B00000100
13130 PIN(16) = _LCD_byte AND &B00001000
13140 PIN(12) = 1 : PIN(12) = 0 : PIN(11) = 0 ' tell lcd to accept data
13150 RETURN
